//*******************************************************************************
//*******************************************************************************
//********** функции обработки сосотояний моторов для режимов *******************
//*******************************************************************************
//*******************************************************************************
void opros_sys_EN_motors()
{
  static bool wait_MOTORS_ON = false;
  static uint32_t safe_start_timer = 0;
  static bool realSTEPER_EN_level = MOTORS_OFF;
  if ((arming == true) && (STEPER_EN_level != MOTORS_ON))
  {
    if (!wait_MOTORS_ON)
    {
      realSTEPER_EN_level = MOTORS_ON;
      digitalWrite(GPIO_MOTORS_EN, MOTORS_ON);
      safe_start_timer = 1000 + millis(); // даем секунду на безопасное включение
      wait_MOTORS_ON = true;
    }
    else
    {
      if (safe_start_timer < millis())
      {
        STEPER_EN_level = MOTORS_ON;
        wait_MOTORS_ON = false;
      }
    }
  }
  else
  { if ((arming == false) && (realSTEPER_EN_level == MOTORS_ON))
    {
      realSTEPER_EN_level = MOTORS_OFF;
      STEPER_EN_level = MOTORS_OFF;
      digitalWrite(GPIO_MOTORS_EN, STEPER_EN_level);

      wait_MOTORS_ON = false;
    }
  }
}
void CalcSpeedAndPosition(double Dt)
{
  //Получаем от приемника два значения
  // 1. Командный угол поворота newROT_Angel_RAD - в радианах
  // 2. Командную скорость newWheelSpeed - в шагах на секунду


  if (STEPER_EN_level == MOTORS_ON)
  {
    RIGHT_WEEL_SPEED = constrain(commandRIGHT_WEEL_SPEED, -MAX_WEEL_SPEED, MAX_WEEL_SPEED);
    LEFT_WEEL_SPEED = constrain(commandLEFT_WEEL_SPEED, -MAX_WEEL_SPEED, MAX_WEEL_SPEED);
  }
  else
  {
    RIGHT_WEEL_SPEED = 0;
    LEFT_WEEL_SPEED = 0;
  }
  reaLsPeedL = 0;
  temp = fabs(LEFT_WEEL_SPEED);
  if (temp >= MIN_WEEL_SPEED) {
    LONG_STEP_WEEL_LEFT = uint32_t(100000.0 / temp);
    LONG_STEP_WEEL_LEFT = constrain(LONG_STEP_WEEL_LEFT, 3, MaxLONGStep);
    reaLsPeedL = 100000.0 / double(LONG_STEP_WEEL_LEFT);
    if (LEFT_WEEL_SPEED < 0) reaLsPeedL = -reaLsPeedL;
  } else  LONG_STEP_WEEL_LEFT = infinity_large_number;
  if (LEFT_WEEL_SPEED < 0.0) dir_STEP_WEEL_LEFT = DIR_LEFT_BACKWARD;
  else dir_STEP_WEEL_LEFT = DIR_LEFT_FORWARD;
  {

    static bool faza0 = false;
    if (DIR_tec_WEEL_LEFT_ != dir_STEP_WEEL_LEFT)
    {
      if (!faza0)
      {
        reaLsPeedL = 0;

        LONG_STEP_WEEL_LEFT = infinity_large_number; // Висим на шаге максимально долго не начиная следующий
        faza0 = true;
      }
      else
      {
        DIR_tec_WEEL_LEFT_ = dir_STEP_WEEL_LEFT;
        digitalWrite(GPIO_LEFT_WEEL_DIR, DIR_tec_WEEL_LEFT_);
        reaLsPeedL = 0;
        faza0 = false;
      }
    }
    else faza0 = false;

    counter_do_step_WEEL_LEFT_ = LONG_STEP_WEEL_LEFT;
  }

  reaLsPeedR = 0;
  temp = fabs(RIGHT_WEEL_SPEED);
  if (temp >= MIN_WEEL_SPEED) {
    LONG_STEP_WEEL_RIGHT = uint32_t(100000.0 / temp);
    LONG_STEP_WEEL_RIGHT = constrain(LONG_STEP_WEEL_RIGHT, 3, MaxLONGStep);

    if (RIGHT_WEEL_SPEED < 0) reaLsPeedR -= 100000.0 / double(LONG_STEP_WEEL_RIGHT);
    else reaLsPeedR += 100000.0 / double(LONG_STEP_WEEL_RIGHT);

  } else LONG_STEP_WEEL_RIGHT = infinity_large_number;
  if (RIGHT_WEEL_SPEED < 0.0) dir_STEP_WEEL_RIGHT = DIR_RIGHT_BACKWARD;
  else dir_STEP_WEEL_RIGHT = DIR_RIGHT_FORWARD;
  {
    static bool faza0 = false;
    if (DIR_tec_WEEL_RIGHT_ != dir_STEP_WEEL_RIGHT)
    {
      if (!faza0)
      {
        reaLsPeedR = 0;

        LONG_STEP_WEEL_RIGHT = infinity_large_number; // Висим на шаге максимально долго не начиная следующий
        faza0 = true;
      }
      else
      {
        DIR_tec_WEEL_RIGHT_ = dir_STEP_WEEL_RIGHT;
        digitalWrite(GPIO_RIGHT_WEEL_DIR, DIR_tec_WEEL_RIGHT_);
        faza0 = false;
      }
    }
    else faza0 = false;
    counter_do_step_WEEL_RIGHT_ = LONG_STEP_WEEL_RIGHT;
  }


  newSpeedflag_ = true;
  //Sbo = (RIGHT_WEEL_SPEED + LEFT_WEEL_SPEED) / 2.0;
  //reaLsPeed *= 0.5;
  Sbo = (reaLsPeedL + reaLsPeedR) * 0.5;
}

//*******************************************************************************
//**************Расчет для прямолинейного движения ******************************
//*******************************************************************************
